program exo3
  implicit none
  integer, parameter      :: n = 10
  real   , dimension(n,n) :: mat_ident
  character(len=8)        :: fmt = "(00f3.0)"

  write(fmt(2:3), '(i2)')n  ! Format d'impression
!
!==============> Premire solution :
  call sol_unpack
  call imp
!
!==============> Deuxime solution :
  call sol_reshape
  call imp
!
!==============> Troisime solution :
  call sol_cshift
  call imp

  contains
    subroutine sol_unpack
      logical, dimension(n,n) :: mask
      real,    dimension(n)   :: diag = 1.
      integer                 :: i, j

      mask = reshape( (/ ((i == j, i=1,n), j=1,n) /), &
                      shape = shape( mask ) )
      mat_ident = unpack(diag, mask, 0.)
    end subroutine sol_unpack
!
    subroutine sol_reshape
      real, dimension(n*n) :: vect = 0.

      vect(1:n*n:n+1) = 1.
      mat_ident = reshape( vect, shape = shape( mat_ident ) )
    end subroutine sol_reshape
!
    subroutine sol_cshift
      integer i

      mat_ident(:,:) = 0.
      mat_ident(:,1) = 1.
      mat_ident(:,:) = cshift( array=mat_ident, &
                               shift=(/ (-i,i=0,n-1) /), &
                               dim=2 )
    end subroutine sol_cshift
!
    subroutine imp
      integer i

      do i=1,n   ! Impression matrice identit
        print fmt,mat_ident(i,:)
      end do
      print *
    end subroutine imp
end program exo3
