MODULE F77_LAPACK
  INTERFACE LA_ILAENV
    FUNCTION ILAENV( ISPEC, NAME, OPTS, N1, N2, N3, N4 )
      INTEGER :: ILAENV
      CHARACTER(LEN=*), INTENT(IN) :: NAME, OPTS
      INTEGER, INTENT(IN) :: ISPEC, N1, N2, N3, N4
    END FUNCTION ILAENV
  END INTERFACE

  INTERFACE LA_GEEV
    SUBROUTINE SGEEV( JOBVL, JOBVR, N, A, LDA, WR, WI, VL, LDVL, VR, &
   &                  LDVR, WORK, LWORK, INFO )
      USE LA_PRECISION, ONLY: WP => SP
      CHARACTER(LEN=1), INTENT(IN) :: JOBVL, JOBVR
      INTEGER, INTENT(IN) :: N, LDA, LDVL, LDVR, LWORK
      INTEGER, INTENT(OUT) :: INFO
      REAL(WP), INTENT(INOUT) :: A(LDA,*)
      REAL(WP), INTENT(OUT) :: VL(LDVL,*), VR(LDVR,*), WR(*), WI(*), &
   &                           WORK(*)
    END SUBROUTINE SGEEV

    SUBROUTINE DGEEV( JOBVL, JOBVR, N, A, LDA, WR, WI, VL, LDVL, VR, &
   &                  LDVR, WORK, LWORK, INFO )
      USE LA_PRECISION, ONLY: WP => DP
      CHARACTER(LEN=1), INTENT(IN) :: JOBVL, JOBVR
      INTEGER, INTENT(IN) :: N, LDA, LDVL, LDVR, LWORK
      INTEGER, INTENT(OUT) :: INFO
      REAL(WP), INTENT(INOUT) :: A(LDA,*)
      REAL(WP), INTENT(OUT) :: VL(LDVL,*), VR(LDVR,*), WR(*), WI(*), &
   &                           WORK(*)
    END SUBROUTINE DGEEV

  END INTERFACE
END MODULE F77_LAPACK
